//More highly sophisticated behaviour, for sheep this time!
//Also an accusation of sheep-fucking, from our good friend Dupre.

const int SHEARED = 28;	//use the MET flag for determining if a sheep has been sheared previously
Sheep 970()
{
	UI_item_say(item, "\"Baa-aa-aa\"");
	if (event == DOUBLECLICK)
	{
		if (UI_get_random(10) < 6 && NPCInParty(SHAMINO) && NPCCanTalk(SHAMINO))
		{
			delayedBark(SHAMINO, "\"I like sheep.\"", 6);
			if (NPCInParty(DUPRE) && NPCCanTalk(DUPRE))
			{ 
				delayedBark(DUPRE, "\"Aye, I hath heard that about thee!\"", 16);
				delayedBark(SHAMINO, "\"Hey!\"", 26);
			}
		}
	}
}

//Organise everything for shearing, and go to the sheep
startShearing 0xB20(var sheep)
{
	UI_close_gumps();

	//The sheep is already sheared
	if (UI_get_item_flag(sheep, SHEARED))
	{
		randomPartySay("\"Thou hast sheared that sheep already! Give the poor thing a chance to grow it back.\"");
		return;
	}

	//make sure the shears are readied first
	if (!UI_is_readied(AVATAR, WEAPON_HAND, SHAPE_SHEARS, FRAME_ANY))
	{
		randomPartySay("\"Thou must have the shears in thy hand.\"");
		return;
	}

	UI_set_schedule_type(sheep, WAIT);	//so it doesn't try to run off

	//Get in behind the sheep (oh, the jokes never cease)
	var sheep_offsetx = [0, -1, 1];
	var sheep_offsety = [1, 1, 1];
	gotoObject(sheep, sheep_offsetx, sheep_offsety, 0, 0xB21, sheep, SCRIPTED);
}

const int SOUND_SHEARING = 0;
//Shear that sheep!
shearSheep 0xB21()
{
	script AVATAR
	{
		call func_freeze;	//paralyze the avatar so the player can't move during sequence

		face NORTH;

		frame STAND;
		frame SWING_2;
		sfx SOUND_SHEARING;
		frame SWING_3;
		wait 2;

		say("\"Easy now...\"");

		frame STAND;
		frame SWING_2;
		sfx SOUND_SHEARING;
		frame SWING_3;
		wait 2;

		frame STAND;
		frame SWING_2;
		sfx SOUND_SHEARING;
		frame SWING_3;
		wait 2;

		frame STAND;
		frame SWING_2;
		sfx SOUND_SHEARING;
		frame SWING_3;
		wait 2;

		frame STAND;
		frame SWING_2;
		sfx SOUND_SHEARING;
		frame SWING_3;
		wait 2;

		frame STAND;
		frame SWING_2;
		sfx SOUND_SHEARING;
		frame SWING_3;
		wait 2;

		call func_unfreeze;	//unparalyze again
	}

	script item	after 10 ticks
	{
		call func_freeze;
		wait 10;
		say "Baaa!";
		wait 25;
		say "Baa-aa-aa!";
		call func_unfreeze;
		call 0xB22;	//Create the wool
	}

	//our resident sheep expert
	if (NPCInParty(KATRINA))
	{
		var barks = [
			"\"Thou art doing it all wrong!\"",
			"\"Nay, work thy way forwards!\"",
			"\"Thou shouldst be a shepherd!\""
		];
		delayedBark(KATRINA, randomIndex(barks), 20);
	}
}

//create the wool beside the Avatar
finishShearing 0xB22()
{
	var wool;
	var target_pos;

	wool = UI_create_new_object(SHAPE_WOOL);

	UI_set_item_frame(wool, 1);	//vertical bale

	UI_set_item_flag(wool, TEMPORARY);
	UI_set_item_flag(wool, OKAY_TO_TAKE);

	target_pos = UI_get_object_position(item);	//place it next to the sheep
	target_pos[X] = target_pos[X] + 1;

	//Todo: stick it in the players inventory if it can't be placed here
	UI_update_last_created(target_pos);

	//Make the sheep run away after the deed is done
	UI_set_schedule_type(item, SHY);
}