//Let's milk us some cow
const int SOUND_MILKING = 2;
milkCow 0xB11()
{
	var cow = item;
	var vessel;			//the empty bucket/pitcher used for milking
	var avatar;
	var filled_frame;	//the correct full-of-milk frame for the bucket/pitcher

	//A bucket is being filled
	if (event == 2)
	{
		//get the first empty bucket we can find that the avatar is carrying
		vessel = UI_get_cont_items(UI_get_avatar_ref(), SHAPE_BUCKET, QUALITY_ANY, FRAME_BUCKET_EMPTY);
		filled_frame = FRAME_BUCKET_MILK;
	}
	//A milk pitcher is being filled
	else if (event == 3)
	{
		//get the first pitcher we can find that the avatar is carrying
		vessel = UI_get_cont_items(UI_get_avatar_ref(), SHAPE_KITCHEN_ITEM, QUALITY_ANY, FRAME_PITCHER_EMPTY);
		filled_frame = FRAME_PITCHER_MILK;
	}

	//place the vessel on the ground beneath the cow
	var target_pos = UI_get_object_position(cow);
	target_pos[X] = target_pos[X] - 2;
	moveToLocation(vessel, target_pos);

	if (UI_get_random(10) < 3) delayedBark(avatar, "\"Hold still...\"", 15);

	script AVATAR
	{
		call func_freeze;	//disable player input while animation is playing
		face WEST;
		frame STAND;
		frame LEAN;		wait 2;
		frame STAND;	wait 2;

		sfx SOUND_MILKING;
		frame USE;		wait 2;
		frame STAND;	wait 2;

		sfx SOUND_MILKING;
		frame USE;		wait 2;
		frame STAND;	wait 2;

		sfx SOUND_MILKING;
		frame USE;	wait 2;
		say "\"That's a good girl!\"";
		frame STAND;

		call func_unfreeze;
	}
	script vessel after 25 ticks	{ frame filled_frame; }
	script cow after 20 ticks		{ say "\"MoooOOOoooo\""; wait 5; call 0xB19; /* Continue grazing */ }

	//Sarky bastards
	if (UI_get_random(3) == 1) delayedBark(getRandomPartyMember(), "\"Don't we have a quest?\"", 30);
}

//Tells the cow to start grazing again
continueGrazing 0xB19()	{ UI_set_schedule_type(item, GRAZE); }

//Called by Bucket() - directs the player to the cow, and freezes the cow in place till he gets there
gotoCow 0xB18(var cow)
{
	UI_set_schedule_type(cow, WAIT);	//stop the cow from moving around
	script cow { face EAST; }			//make sure the cow is facing the right way for milking

	//UI_execute_usecode_array(cow, [0x27, 1, 0x0B, -2, 0x0032]);	//ok, then what the fuck is this doing?

	//Go to the cow's udder region (either side will do)
	var cow_offsetx = [-2, -2];
	var cow_offsety = [1, -4];
	gotoObject(cow, cow_offsetx, cow_offsety, 0, 0xB11, cow, SCRIPTED);
}